% Created 2019-08-12 ma 13:05
% Intended LaTeX compiler: xelatex
\documentclass[a4paper, 11pt]{article}
    \input{/home/bram/.dotfiles/latex/agda.tex}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\author{Bram van den Boomen}
\date{\today}
\title{Proof search for type-logical grammars in Agda\\\medskip
\large Master Thesis Proposal}
\hypersetup{
 pdfauthor={Bram van den Boomen},
 pdftitle={Proof search for type-logical grammars in Agda},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 26.2 (Org mode 9.1.9)}, 
 pdflang={English}}
\begin{document}

\maketitle
\section{Introduction}
\label{sec:org38162be}

With the current level of interest in both the world of categorial grammars and automated proof assistants, it seems only logical that these two worlds would collide sooner than later. 
More often than not though, discussion about proof search for categorial grammars tend not to end with the implementation or even a proof of concept, but with the theoretical feasibility, which does not always translate well to the real world (as we will see in chapter \ref{kanazawa}). On the other side of the spectrum, much of the discussion around proof assistants, especially the discourse around dependent types, tends to stay in the relative obscurity of theoretical computer-science research. In this research we want to properly introduce dependently-typed programming and proof-assistants to type-logical grammars.

Using proof assistants for categorial grammars can be a boon in multiple ways. Firstly, formalizing categorial proofs in a proof assistant not only allows us to validate the correctness of these proofs but it also allows us to execute the proof and check the results directly. Secondly, running proofs as programs allows us to apply our proofs to actual data. The ability to do both in the same environment gives us the best of both worlds. While there are several proof-assistants and other programming environments that would lend themselves to verification and application of proofs, we believe Agda is the strongest contender for the job. While we will discuss the details of this choice in chapter \ref{agda}, we believe that the syntax of Agda allows us to formalize our proofs very elegantly and transparently, to the point that there should be little difference between the Agda-program and the actual implemented proof.

The question we would like to answer in this research will therefore be: How can we wield the power of Agda as a dependently typed proof assistant to automate proof search for type-logical grammars?
Ultimately we would like to develop a method for automated proof search for the extended Lambek Calculus with modalities for licensed commutativity and associativity as developed by \cite{moortgat1997}. As a secondary goal we would like to leverage the syntactic freedom that Agda offers to make this automated proof search understandable and transparent for anyone familiar with the underlying theory, without the need to be fluent in Agda.

To be able to develop this method, we will need the following components to be fully implemented in Agda before we can consider the methods and intricacies of actual proof-search (Chapter \ref{proofsearch}).

\begin{itemize}
\item A formalization in Agda of the type-logical grammars we want to do proof search for. (Chapter \ref{Prelude})
\item A method for unification of types. (Chapter \ref{unification})
\item Methods of constraining the search-space. (Chapter \ref{searchspace})
\end{itemize}


\section{Background}
\label{sec:org364c6d3}

\subsection{Type-Logical Grammars \label{grammars}}
\label{sec:org18d5e1d}

As we consider the background regarding type-logical grammars will be largely known to the reader we will just summarize our area of interest regarding these grammars. For a proper summary of the relevant theory we refer the reader to \citep{moortgat1997}.

We will mainly work with the following logics:
\begin{itemize}
\item Inuitionistic Logic (IL)
\item Inuitionistic Linear Logic (ILL)
\item Lambek Calculus (NL)
\begin{itemize}
\item Associative (L)
\item Commutative (LP)
\item Structural control (SC)
\end{itemize}
\end{itemize}
These logics can be considered a hierarchy of logics, where IL is our base-logic, ILL introduces resource-sensitivity and NL introduces directionality. As we will be mainly interested in the Lambek system, we have included its rules below in natural deduction style.

\newcommand{\arr}[2]{#1 \rightarrow #2}
\newcommand{\nd}[2]{#1 \vdash #2}
\renewcommand{\to}{\vdash}
\newcommand{\bs}{\backslash}
\newcommand{\fs}{/}

\textbf{NL}

\[\addtolength{\inferLineSkip}{1pt}
\infer[\bs E]{\nd{X\cdot Y}{B}}{\nd{X}{A} & \nd{Y}{A\bs B}}
\qquad
\infer[\slash E]{\nd{X\cdot Y}{B}}{\nd{X}{B \fs A} & \nd{Y}{A}}
\]
%
\[\addtolength{\inferLineSkip}{1pt}
\infer[\bs I]{\nd{X}{A\bs B}}{\nd{A\cdot X}{B}}
\qquad
\infer[\slash I]{\nd{X}{B \fs A}}{\nd{X\cdot A}{B}}
\]
%
\[\addtolength{\inferLineSkip}{1pt}
\infer[\otimes I]{\nd{X\cdot Y}{A\otimes B}}{\nd{X}{A} & \nd{Y}{B}}
\qquad
\infer[\otimes E]{\nd{X[Y]}{C}}{\nd{Y}{A\otimes B} & \nd{X[A\cdot B]}{C}}
\]

\textbf{L}=\textbf{NL}+ass$^{l}$,ass$^{r}$

\[\addtolength{\inferLineSkip}{1pt}
\infer[\texttt{ass}^l]{X[(Y\cdot Z)\cdot W] \to D}{X[Y \cdot (Z \cdot W)] \to D}
\qquad
\infer[\texttt{ass}^r]{X[Y\cdot (Z\cdot W)] \to D}{X[(Y \cdot Z) \cdot W] \to D}
\]

\textbf{LP}=\textbf{L}+comm

\[
\infer[\texttt{comm}]{X[Y\cdot Z] \to C}{X[Z\cdot Y] \to C}
\]

\textbf{SC}=\textbf{NL}+\(\Diamond E,\Diamond I,\Box E,\Box I,R1,R2\)

\[\addtolength{\inferLineSkip}{1pt}
\infer[\Box E]{\nd{\langle X \rangle}{A}}{\nd{X}{\Box A}}
\qquad
\infer[\Box I]{\nd{X}{\Box A}}{\nd{\langle X \rangle}{A}}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[\Diamond E]{\nd{X[Y]}{B}}{\nd{Y}{\Diamond A} & \nd{X[\langle A \rangle]}{B}}
\qquad
\infer[\Diamond I]{\nd{\langle X \rangle}{\Diamond A}}{\nd{X}{A}}
\]

\[\addtolength{\inferLineSkip}{1pt}
\infer[R1]{X[W \cdot (Y \cdot \langle Z \rangle)] \to A}{X[(W \cdot Y) \cdot \langle Z \rangle] \to A}
\qquad
\infer[R1']{X[(\langle W \rangle \cdot Y) \cdot Z] \to A}{X[\langle W \rangle \cdot (Y \cdot Z)] \to A}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[R2]{X[(W \cdot Y) \cdot \langle Z \rangle] \to A}{X[(W \cdot \langle Z \rangle) \cdot Y] \to A}
\qquad
\infer[R2']{X[\langle W \rangle \cdot (Y \cdot Z)] \to A}{X[Y \cdot (\langle W \rangle \cdot Z)] \to A}
\]

When analyzing natural language using these logics, different sets of rules are advantageous compared to others in different situations. For instance, when we want both the sentence "\emph{de geit loopt niet}" (the goat doesn't walk) and "\emph{ik weet dat de geit niet loopt}" (I know that the goat doesn't walk), to be accepted by our grammar, it seems obvious that we need commutativity to be able to accept words that are not in order. However, when we introduce unrestricted commutativity, we essentially allow words to be in \emph{any} order, which is an undesirable property for most languages. One of the more elegant and advanced solutions to this is to use licensed associativity and commutativity (SC). In our example, the word "\emph{dat}" will carry with it the modalities that allow the following subsentence to be reordered. This logic does introduce a new layer of complexity however, which is why we will perform our investigations mainly in less complex logics, but this is ultimately our target logic.

\subsection{Agda \label{agda}}
\label{sec:org90e4952}
\subsubsection{Overview}
\label{sec:orgdbb359d}

Agda is first and foremost a `dependently typed, functional programming language'. Where most readers will be familiar with typed programming languages, Agda is based on Martin-Löf's type theory, which allows types to be indexed by other types \citep{bove2009}. This is a very powerful mechanism as it allows Agda's type-system and type-checker to exert a great deal of control over the written program. As with any typed programming language, the type-checker is the gatekeeper that ensures compiled code is `safe' up to a certain point. For instance, if a function \texttt{even} has the type \texttt{even : Nat → Bool}, any program that calls this function with a \texttt{String} as argument will not compile. Dependent types take this concept a step further. For instance, if we would want to define a function \texttt{tail} that takes a vector and returns that vector without the first element, without dependent types this function would have the type \texttt{tail : Vector → Vector}. However, the compiler would require the programmer to define a case for \texttt{tail} where its argument is the empty vector (\texttt{[]}). In the dependently typed case however, we can define the type \texttt{Vector} to have a certain length: i.e. the type \texttt{Vector} would be indexed over the natural numbers (\texttt{ℕ}). The type of \texttt{tail} could then be defined as taking a vector of a length larger than zero, and returning a vector with that length minus one (see figure \ref{agdavec}).

This definition of \texttt{tail} saves us the trouble of writing escape clauses or error handlers for when the user tries to 'tail' an empty vector, which is why Agda programs are sometimes referred to as having `correctness by construction'. Of course, nothing prevents us from writing a tail-function that does not behave as we would expect, for instance, the function \texttt{tail*} (see figure \ref{agdavec}) that cuts off only the last element of a vector would have the same type-signature as the `correct' tail function and as a result, our program could still behave unexpectedly. Even so, Agda's compiler is a lot more adept at catching and preventing human error compared to its non-dependently typed counterparts.

A nice side-effect is that, when well-constructed, Agda programs need very little in the way of error-handling. This makes Agda code very readable, without the need to skip through language-overhead. As a result, we can formalize theorems very closely to how we would on paper, which is an obvious advantage when using Agda to check or present proofs in publicised papers.

\begin{enumerate}
\item Syntax overview
\label{sec:org4450db2}

As there will be a few snippets of Agda-code below, we will very briefly introduce some of Agda's syntax. Take note that this overview will only encompass the bare necessities to read the code in this paper, for a more complete overview we would refer the reader to the official Agda documentation\footnote{\url{https://agda.readthedocs.io}} and the introductory paper by \cite{norellDependentlyTypedProgramming}.

Agda code is syntactically very similar to Haskell code, in fact as Agda is implemented in Haskell, compiled Agda code actually translates to Haskell. We will recap some Haskell syntax principles very briefly for those not familiar with the language.

\begin{enumerate}
\item Datatypes
\label{sec:org896cda4}

A new datatype is introduced by the keyword \texttt{data}, and followed by the indented constructors for that type. The following code can be read as ``The natural numbers (\texttt{Nat}) are defined as following: \texttt{zero} is a natural number, and the successor (\texttt{suc}) of a natural number is also a natural number.''

\begin{verbatim}
data Nat : Set where
  zero : Nat
  suc  : Nat → Nat
\end{verbatim}

\item Functions
\label{sec:orgb999b44}

Any function has two components: the type-signature, which describes how the function should be used, and the function definition, which describes what the function does.

Here the same principles as with Haskell apply: The type-signature appears above the function definition where \texttt{f : A → B → C} means: ``function \texttt{f} takes an argument of type \texttt{A}, an argument of type \texttt{B} to compute a value of type \texttt{C}''. Currying applies, so that this also means ``function \texttt{f} takes an argument of type \texttt{A} to produce a function of type \texttt{B → C}''. Function application is simply the function followed by its arguments: for function \texttt{f : A → B → C}, \texttt{x : A} and \texttt{y : B}, \texttt{f x y} is of type \texttt{C} and \texttt{f x} is of type \texttt{B → C}.

\begin{verbatim}
increment : Nat → Nat  -- Type signature
increment n = suc n    -- Function definition
\end{verbatim}

We can introduce infix operators by using underscores in the function name as placeholders for the arguments to the function.

\begin{verbatim}
_+_ : Nat → Nat → Nat
zero    + n = n
(suc m) + n = suc (n + m)
\end{verbatim}

The following applications are all equivalent:

\begin{verbatim}
p + q
_+_ p q
(_+ q) p
(_+_ p) q
\end{verbatim}

\item Dependent Types
\label{sec:orgd862c63}

A datatype can have `parameters', which need to be the same for all constructors. For instance, in the datatype for \texttt{List} we have an argument which we call \texttt{A}, which is the type of elements that go into the list.

\begin{verbatim}
data List (A : Set) : Set where
   ø   : List A
  _∷_  : A → List A → List A
\end{verbatim}

Similarly, a datatype can also be indexed over another type. In this case the type does not need to have the same value in each constructor. For example, below we have the type for vectors of a certain length, which is parametrized over \texttt{Set} and indexed over \texttt{Nat}, where the constructor \texttt{\_∷\_} increments the length of the vector.

\begin{verbatim}
data Vector (A : Set) : Nat → Set where
  []  : Vector A zero
  _∷_ : ∀ {n : Nat} (x : A) (xs : Vector A n) → Vector A (suc n)
\end{verbatim}

\item Arguments
\label{sec:orged5d315}

Arguments to functions in Agda can be either explicit or implicit. When we want to have an argument be implicit, it is enclosed in curly brackets (\texttt{\{ \}}). Also, we can name specific types, to reuse them in type or function definitions, this is done by a colon within brackets (\texttt{\{m : Nat\}}). Explicit arguments are either not enclosed in brackets (unnamed) or enclosed in brackets when named (\texttt{(A : Set)}). Also, for brevity, type definitions can be shortened by the following conventions:
\begin{itemize}
\item \texttt{\{m n : Nat\}} desugars to \texttt{\{m : Nat\} → \{n : Nat\}}
\item \texttt{\{m : Nat\}(n : Nat) → Nat} desugars to \texttt{\{m : Nat\} → (n : Nat) → Nat}
\end{itemize}

\begin{verbatim}
concat : {m n : Nat}{A : Set} → Vector A n → Vector A m → Vector A (n + m)
concat [] ys = ys
concat (x ∷ xs) ys = x ∷ (concat xs ys)
\end{verbatim}
\end{enumerate}

\item Tail function
\label{sec:orgfdf53b2}

\begin{verbatim}
tail : {n : Nat}{A : Set} → Vector A (suc n) → Vector A n
tail (x ∷ xs) = xs
-- There is no constructor for `tail []`

tail* : {n : Nat}{A : Set} → Vector A (suc n) → Vector A n
tail* (x ∷ []) = []
tail* (x ∷ (xs ∷ xss)) = x ∷ (tail* (xs ∷ xss))
\end{verbatim}
\captionof{figure}{Implementation of the tail function in Agda \label{agdavec}}
\end{enumerate}

\subsubsection{Justification and alternatives}
\label{sec:orgacb2802}

Of course, Agda is not the only proof assistant and also not the only dependently typed programming language out there. The most obvious contender to Agda is the proof assistant \emph{Coq}. Coq is a dependently typed programming language, based on Martin-Löf's type theory as well. Also, Coq is both more mature and better documented compared to Agda. Lastly, because of Agda's need to be interpreted into Haskell before compilation (which is inherently inefficient because Haskell is not dependently typed), Coq would most likely be the faster and more efficient language.

For this project we have decided to use Agda mainly for syntactic reasons. One area where Coq does not seem very well suited for this project is readability. Coq programs tend to be heavy in overhead, and Coq uses a separate `tactic' language for proof-search and heuristics. Agda does not provide a separate tactic method, it forces programmers to program these tactics in the core language itself. Coupled with the inherited simplicity of the Haskell syntax, Agda programs are necessarily explicit about tactics and generally readable by design \citep{swierstra2010}.

Other alternatives to Agda include \emph{Isabelle} and \emph{Idris}. Where Isabelle suffers from the same shortcomings as Coq, Idris suffers mostly the same problems as Agda. Compared to Idris, which was designed to be a more general-purpose programming language with dependent types, Agda's syntax is slightly more elegant and easier to learn.

It is unlikely, however, that the algorithms implemented in Agda which would be presented in the final paper would be actually of use with real-world data. Not unlike programs written in Prolog, few Agda programs will tend to be used outside of academia. Agda itself is more suitable for prototyping of algorithms in a explicit and understandable fashion. Finalized versions of these prototypes are more suitably implemented in more mature and optimized languages like Haskell. An exiting development to watch out for would be the extension of dependent types to Haskell, which is currently being refined, and which would make the translation from Agda to Haskell code much easier.

\subsection{Type Inference \& Proof Search}
\label{sec:org0a1dcdd}
\subsubsection{Unification \label{unification}}
\label{sec:org92ef1e0}

Ultimately, we want to program algorithms in Agda that perform proof-search, where we want to be able to do something akin to Hindley-Milner type inference. One of the main components these type of algorithm depend on is unification. In Hindley-Milner type inference, for instance, we want to be able to find the most general type for a given expression, which requires the most general unifier (mgu).

Unification is the process of finding instantiations of variables within types such that the resulting type is equal to another type. The instantiation of types that result in the smallest amount of unique types is called the most general unifier.

Let us take a set of types, where \texttt{x, y, u, z} are variables and \texttt{1, 2} are constants.
\begin{verbatim}
{ x, x → y, 1 → u, 2 → (z → z), z → u }
\end{verbatim}
If we take a instantiation where \texttt{\{ x ↤ 1, y ↤ u \}}, then the resulting set of types will be \texttt{\{ 1 , 1 → u, 2 → (z → z), z → u \}} which eliminates one type. The substitution \texttt{\{ x ↤ 2, y ↤ (z → z) \}} also eliminates one type, in fact, both of these unifiers are equally general. Substitutions like \texttt{\{ x ↤ (x → y) \}} are not possible, because \texttt{x} occurs in \texttt{x → y}, and \texttt{\{ 1 ↤ 2, u ↤ (z → z) \}} is not possible because constants cannot be instantiated. Finally, a mgu in this case is \texttt{\{ x ↤ 1, y ↤ u, z ↤ 1 \}} after which no further unification is possible.
A small sidenote is that when considering the directional connectives \texttt{x \textbackslash{} y} and \texttt{u / z} from the Lambek calculus, unification is only possible when the connectives in the terms match.

In many papers regarding type-inference this step is omitted because the implementation is often written in Prolog, which has a built-in unification algorithm at the core of the language. Agda, however, has no built-in unification algorithm that is readily available to the user, which means that we will need to construct a unification module that can be applied to our defined types. A generally effective algorithm has been found in \cite{mcbride2003} which will be discussed in \ref{Unification}.

\subsubsection{Search-space and Heuristics \label{searchspace}}
\label{sec:org438e574}

The main problem that will need to be addressed when considering methods of proof search (or any search for that matter) is the size of the search-space. As we have seen in chapter \ref{grammars}, different logic systems have advantages over others in different areas. This is also true for the search-space that these logics provide. To illustrate: if we just take the logic \texttt{IL} (without the cut-rule) and add only the structural associativity rules, we end up with a potentially infinite search space, because without any control, our algorithm could apply and undo the same associative rule over and over. This is of course a relatively simple problem to solve, but another potential problem are logics in which the cut-rule is a rule. Because we will tend to want to do bottom-up search, the cut-rule will necessarily make our search-space infinite, because we can introduce anything as the information that is lost by the application of the rule (\emph{B} in the cut-rule below)

\begin{proof}
\[\infer[\circ \text{ (cut)}]{A \rightarrow C}{A \rightarrow B & B \rightarrow C}\]
\end{proof}

There are multiple ways around these types of issues. In the case of associative (or commutative) rules, it might suffice to constrain the proof search to fail if it reaches a state in which it has been before, i.e. the proof should be in normal form. In the case of the cut-rule, we have multiple options. In the case that the cut-rule is admissible, it would be advantageous to replace the rule in its entirety with less problematic rules that allow for the same proofs. In the case of \texttt{IL} we can replace the cut-rule with the monotonicity rules, which provide a finite search space.

In other logics, the cut-rule might not be an admissible rule, in which case we have to resort to less elegant solutions. One of which would be to apply formal heuristics. A good example for our logic would be polarisation, of which there is a very nice implementation in Agda by Wen Kokke \citep{kokke2017}. By using polarisation we restrict the possible introduction of types to the types (and subtypes) that are present in the term for which we are trying to find a proof. This way, we make sure that our search space is at least not infinitely large.

When adjustment of the logical rules and formal heuristics are no longer an option, we will have to resort to intuition. In many cases it would be efficient to exhaust application of introduction rules before applying elimination rules because it will restrict the branching of the subproofs necessary for the main proof. This heuristic is not much more than a general intuition about these types of proof however, and should not be treated in the same manner as formal heuristics. The difference being that we can prove the reduction of the search space in the case of formal heuristics so we can convince Agda that our proof search will be terminating (maybe even within \texttt{x} steps). Another potentially promising avenue could be to analyze proofs within the same logics and use automated learning algorithms to determine which rule-application or type-introduction would be most likely to lead to a successful proof. This approach would not be in the scope of this research but there have been some success in this area, most notably by \cite{kaliszyk2017}. It would be interesting nonetheless to provide a top-down control mechanism for these types of `intuitions' in our proof search. One way to provide this control would be to include an `oracle' parameter to our search function, which would take precedence over the standard search parameter, but which could be left empty. In such a case, we could supply Agda with external information and still prove that our search function behaves as expected.


\section{Proof Search \label{proofsearch}}
\label{sec:org0700de0}

As there are many approaches to automated proof search suitable for our purposes, we will summarize the most promising algorithms from the relevant literature below. Because the feasibility in Agda of these algorithms has been investigated, we will make some references to the Agda prototypes of these algorithms, some of which are included in chapter \ref{prototypes}.

\subsection{Kokke \& Swierstra \label{swierstra}}
\label{sec:org62c6d55}

A first avenue to consider when looking at proof search when starting with Agda is its automated theorem prover `Agsy'. Agsy is comparable to the automated theorem prover that Coq uses for `general' proof search. The application in this case is to try a large amount of pre-defined tactics to search for a solution. This approach is not always efficient but it has the advantage that it can be applied to any situation, as long as it is implemented in Agda. Agsy does not provide a large amount of control to the user, however, and as it is implemented in Haskell instead of Agda itself it is not feasible to use the Agsy to complement our envisioned proof search \citep{lindblad2004,kokke2015}.

Precisely because of these shortcomings, Wen Kokke and Wouter Swierstra have developed an alternative to Agsy, implemented in Agda itself \citep{kokke2015}. Their automated theorem prover, `Auto', uses reflection, Agda's meta-programming interface, to pre-process the Agda code and perform proof search using a list of `hints' provided by the user. At the heart of Auto lies the same unification algorithm by McBride as mentioned in chapter \ref{unification}. These properties make Auto to be an algorithm that is near to what we are trying to do in this research.

The main reason to not simply adapt and optimize this approach for application to the logics that we are interested in, is the reflection-component of Auto. Obviously, when developing an automated theorem solver for Agda, in Agda, meta-programming is not optional. Using meta-programming, however, opens us up to a host of complexity-issues, not the least of which is readability. Because one of our aims in this research, and the reason for our choice to use Agda, is to be able to do proof search elegantly and transparently, using reflection would above all stand in the way of that goal. As we are not looking to analyze or pre-process Agda code though, it is overall no problem to omit meta-programming altogether for our implementation.

Even so, especially because Auto uses the same unification algorithm that we are using, techniques from this theorem solver will be useful to analyze for our implementation.

\subsection{Buszkowski \& Penn \label{buszkowski}}
\label{sec:orge816d63}

Buszkowski and Penn, in their 1990 paper, propose an algorithm with which to extract types from FA-structured sentences \citep{buszkowski1990}. FA-structures are binary trees in which each node has an argument-branch and a functor-branch and in which the leaves are the words that the sentence contains.

In our notation we use \texttt{f ◃ a} to mean that the functor is on the left branch of the node and \texttt{a ▹ f} to mean the functor is on the right branch. Each node and leaf have a type which is noted by \texttt{e :- T}.

The algorithm follows the following steps:

\begin{enumerate}
\item Decorate the top node with the target type.
\item Decorate the arguments of all the FA-structures.
\item Infer the types of the functor elements of the FA-structures using the following rules:
\begin{enumerate}
\item \texttt{((a :- A) ▹ (f :- A\textbackslash{}B)) :- B}
\item \texttt{((f :- B/A) ◃ (a :- A)) :- A}
\end{enumerate}
\item For each word in the lexicon, collect the types and perform unification on the set of types for each word, where unification is applied globally over the lexicon. When unification fails, the algorithm fails.
\end{enumerate}

There are some drawbacks to this method. Firstly, for a larger database of FA-structures, the unification-algorithm has to keep track of a large number of instantiations which it needs to check for incompatibilities, which can increase complexity considerably. This might be mitigated by applying the substitution as soon as it is found, and performing unification on the resulting set, which reduces the need of extensive bookkeeping. This does make backtracking more problematic, but it is uncertain if this would affect our project much.

Another problem with this approach is that in some cases, we want the words of our lexicon to have multiple types, which this algorithm does not allow. If we take the following context-free grammar for instance:
\#+caption Grammar G generates the language aⁿbⁿ where \(n > 0\). \label{anbn}
\begin{verbatim}
B S₁ : Struct
S₂   : Struct → Struct

B  = b                   -- B ← b
S₁ = a ◃ B               -- S ← ab
S₂ = λ σ → (a ◃ σ) ◃ b   -- S ← aSb
\end{verbatim}

We would like to end up with the following types: \texttt{\{b :- B, a :- S/B, a :- S/S/B\}}. Because \texttt{S/B} and \texttt{S/S/B} have no unifier however the algorithm will fail for FA-structures generated by this grammar (for \texttt{n > 1} at least). This shortcoming will affect at least all cases where we expect polymorphic types. Makoto Kanazawa, in his 1995 publication proposes a solution to this problem, which will be discussed in the next chapter (\ref{kanazawa}). Another, admittedly naive, solution would be to `unify as much as possible'. This approach (the implementation of which will be discussed in chapter \ref{Decorate}), which is not as sound and reliable as the method by Kanazawa, is much more computationally attractive and preliminary results seem to be correct.

\subsection{K-partial Unification \label{kanazawa}}
\label{sec:orgc80c0c9}

In his book ``Learnable Classes of Categorial Grammar'' Kanazawa proposes an alternative to the `rigid' algorithm by Buszkowski and Penn (algorithm RG by Kanazawa's convention), which he uses what he calls k-partial unification. This algorithm, which he calls VG\(_{\text{k}}\), is able to learn k-valued grammars, which are grammars where \texttt{k} is the maximum number of types that a word in that grammar can have (our previous \texttt{aⁿbⁿ} grammar for example is a 2-valued grammar) \citep{kanazawa1995}.

The approach for VG\(_{\text{k}}\) is to take the k-partition of the collected types (instead of step 4. in algorithm RG) and perform unification on the obtained subsets.

Kanazawa defines a k-partition as following \citep{kanazawa1995}:

Let \(A = {\mathbf{A_1 , ... , \mathbf{A_n}}\) be a family of sets of types.\\
If \(B_i = {B_{i,1} , ... , B_{i,l_i}}\) is a partition of \(\mathbf{A_i}\) for \(1 \le i \le n\), then the family $$B = \bigcup \{ B_i | 1 \le i ≤ n \}$$ is called a partition of \(A\). \(B\) is called a k-partition of \(A\) if \(l_i \le k\) for each \(i\).

The notion of k-partition is better illustrated with an example:
Informally, if we would like to take the 2-partition of A, we would take a set of sets, where all subsets have a maximum of 2 elements and where every element of A is represented in the collection of subsets. \footnote{Because agda reserves the backslash for lambda-expressions, we replace the $\backslash$ and / connectives with "⟫" and "⟪" respectively.}

\begin{verbatim}
A B₁₋₉ : {n : Nat} → List (List (Type n))

A = [ [ α , β ⟫ s , s ⟪ β ] , [ β , γ , s ⟪ γ ] ]

B₁ = [ [ β ⟫ s , s ⟪ β ] , [ α ] , [ γ , s ⟪ γ ] , [ β ] ]
B₂ = [ [ β ⟫ s , s ⟪ β ] , [ α ] , [ β , s ⟪ γ ] , [ γ ] ]
B₃ = [ [ β ⟫ s , s ⟪ β ] , [ α ] , [ s ⟪ γ ] , [ β , γ ] ]
B₄ = [ [ α , s ⟪ β ] , [ β ⟫ s ] , [ γ , s ⟪ γ ] , [ β ] ]
B₅ = [ [ α , s ⟪ β ] , [ β ⟫ s ] , [ β , s ⟪ γ ] , [ γ ] ]
B₆ = [ [ α , s ⟪ β ] , [ β ⟫ s ] , [ s ⟪ γ ] , [ β , γ ] ]
B₇ = [ [ s ⟪ β ] , [ α , β ⟫ s ] , [ γ , s ⟪ γ ] , [ β ] ]
B₈ = [ [ s ⟪ β ] , [ α , β ⟫ s ] , [ β , s ⟪ γ ] , [ γ ] ]
B₉ = [ [ s ⟪ β ] , [ α , β ⟫ s ] , [ s ⟪ γ ] , [ β , γ ] ]

\end{verbatim}
\captionof{figure}{B₁₋₉ are all 2-partitions of A.}

When we find the mgu for each of these k-partitions and perform the corresponding substitutions, we can select the resulting set that is the most general.

The advantage of this approach is that we end up with a type assignment that is guaranteed to be k-valued for any k-valued grammar. The obvious drawback however is the increase in complexity that k-partitions introduce. It can be shown that finding all k-partitions for a family of sets of types takes polynomial time, on top of that, each of these k-partitions need to be unified, which multiplies the complexity of computation further. To illustrate: If we generate a set of sentences using our grammar \texttt{G} from \ref{anbn} where we generate all possible sentences up to n, the number of partitions grows as following:

\begin{center}
\begin{tabular}{rlr}
n & Sentences & number of 2-partitions\\
\hline
1 & ab & 1\\
2 & ab aabb & 9\\
3 & ab aabb aaabbb & 961\\
4 & ab aabb aaabbb aaaabbbb & 261121\\
\end{tabular}
\end{center}

As this is clearly unfeasible when processing natural language, this approach may be entirely unsuitable for our purposes. Because of its k-valued property however, it might be worthwhile to check if our initial decorated types (after step 3. of algorithm RG) can be pre-processed by the naive non-failing unification algorithm described in the last chapter (ch. \ref{buszkowski}) to increase its efficiency but retain the properties that algorithm VG\(_{\text{k}}\) provides.

\subsection{Morris \& van Emden \label{morris}}
\label{sec:orgff184ea}

A second method for type-inference can be found in \cite{vanemden1988}. This approach is reminiscent of that of Buszkowski in that the first step constitute of decorating the terms we try to type with variables, then inferring the type of subterms according to a set of rules and finally using unification to obtain the most general term. 

The implementation described by van Emden uses the `Morris algorithm' for these steps to infer types from lambda terms. The procedure is described as following:
\begin{enumerate}
\item All variables get instantiated with fresh meta-variables (where variables that occur more than once obtain the same meta-variable).
\item Subterms where lambda-abstraction is the top-most connective get typed according to the following rule:
$$\text{If } x:S \text{ and } M:T \text{, then } (\lambda x.M):(S\rightarrow T)$$
\item Subterms where function-application is the top-most connective get typed according to the following rule:
$$\text{If } M:(S \rightarrow T) \text{ and } N:S \text{, then } (MN):T$$
\item The resulting collection of meta-types constitute a unification-problem which if it succeeds results in the type of the term. If unification fails, the term does not type.
\end{enumerate}

The first advantage that this approach has over the algorithm RG by Buszkowski and Penn is that it not only deals with function-application, but with abstraction as well. The immediately obvious shortcoming on the other hand, is that this approach does not deal with directional connectives. As steps 2 and 3 illustrate however, it should be possible to extend this algorithm with the rules of the logics that we are interested in, where we replace for instance the rule from step 3 with the following rules:
$$\text{If } M:(T / S) \text{ and } N:S \text{, then }(M ◃ N):T$$
$$\text{If } M:(S \textbackslash T) \text{ and } N:S \text{, then } (N ▹ M):T$$

This approach seems like the most promising avenue to explore further. Certainly when combined with the insights from the Buszkowski and Penn algorithm to not only infer types for single expressions, but to learn grammars from structured data.


\section{Algorithm Prototypes \label{prototypes}}
\label{sec:org7fcdcdf}

Below are the results from our investigations regarding the mentioned literature in chapter \ref{proofsearch}. For brevity, most import statements and utility functions have been omitted here, the final versions of these modules can be found on \href{https://gitlab.com/bram.boomen/thesis-proposal}{my gitlab page}.

\subsection{Calculus Datatypes \label{Prelude}}
\label{sec:orgc69a1c1}

To work with specific logics, we first want to design proper data-types which encode these logics in Agda. Luckily, this is fairly straightforward in Agda. As an example, we will show the construction of a datatype for the natural deduction rules of IL. We first define what a sequent is in our natural deduction proof.

\begin{verbatim}
data Natural : Set where
  _⊢_ : Struct → Type → Natural
\end{verbatim}

To constrain our datatype to only allow well-formed formulas within our calculus, we define the following datatype to be our main proof type:

\begin{verbatim}
data NLn_ : Natural → Set where
  ax : (A : Struct) → NLn A ⊢ [ A ]ᵀ
  ⟪E : ∀ {A B   X Y} → NLn X ⊢ B ⟪ A → NLn Y ⊢ A → NLn X ∙ Y ⊢ B
  ⟫E : ∀ {A B   X Y} → NLn X ⊢ A → NLn Y ⊢ A ⟫ B → NLn X ∙ Y ⊢ B
  ⊗E : ∀ {A B C   Y}{X[A∙B] X[Y]}{s1 : (A ∙ B) ∈s X[A∙B]}{s2 : Y ∈s X[Y]}
    → (s3 : ((X[A∙B] ─ (A ∙ B)) s1) ≡ ((X[Y] ─ Y) s2))
    → NLn Y ⊢ [ A ]ᵀ ⊗ [ B ]ᵀ → NLn X[A∙B] ⊢ C → NLn X[Y] ⊢ C
  ⟪I : ∀ {A B   X  } → NLn X ∙ A ⊢ B → NLn X ⊢ B ⟪ [ A ]ᵀ
  ⟫I : ∀ {A B   X  } → NLn A ∙ X ⊢ B → NLn X ⊢ [ A ]ᵀ ⟫ B
  ⊗I : ∀ {A B   X Y} → NLn X ⊢ A → NLn Y ⊢ B → NLn X ∙ Y ⊢ A ⊗ B
\end{verbatim}

The rule for ⊗E seems daunting, but the \texttt{s1}, \texttt{s2} and \texttt{s3} expressions are only there to make sure that \texttt{X} without \texttt{A ∙ B} is equal to \texttt{X} without \texttt{Y}. Another, maybe even more elegant, approach would be to use a display calculus instead in the future.

This datatype allows us to construct proof terms for certain expressions:

\begin{verbatim}
arg-lower : NLn ⌈ (np ⟫ s) ⟪ ((s ⟪ np) ⟫ s) ⌉ ⊢ (np ⟫ s) ⟪ np
arg-lower = ⟪I
              (⟫I
                (⟫E
                  ( ax ⌈ np ⌉ )
                  (⟪E
                    (ax ⌈ (np ⟫ s) ⟪ ((s ⟪ np) ⟫ s) ⌉)
                    (⟫I
                      (⟪E
                        (ax ⌈ s ⟪ np ⌉)
                        (ax ⌈ np ⌉))))))
\end{verbatim}

Including associativity or commutativity for this logic is simply a matter of adding these rules to the type:

\begin{verbatim}
  assᵣ : ∀ {Y Z W D XR XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
    → LPn XL ⊢ D → LPn XR ⊢ D
  assₗ : ∀ {Y Z W D XR XL}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
    → LPn XR ⊢ D → LPn XL ⊢ D

  comm : ∀ {Y Z C}{X₁ X₂}{s1 : (Z ∙ Y) ∈s X₁}{s2 : (Y ∙ Z) ∈s X₂}
    (s3 : ((X₁ ─ (Z ∙ Y)) s1) ≡ ((X₂ ─ (Y ∙ Z)) s2))
    → LPn X₁ ⊢ C → LPn X₂ ⊢ C
\end{verbatim}

Other rules, like rules for structural control can be added in the same way and other calculi, like Gentzen style or display calculi can be formalized in the same fashion as this example for natural deduction.

\subsection{Unification \label{Unification}}
\label{sec:org9c2c39d}

We will not include the unification module in its entirety, as the design is described very well in \cite{mcbride2003}, and the Agda implementation is a near one-on-one translation of that description. The main difference that we implemented here is the design of the \texttt{Type} datatype.
Because we want to be able to unify directional types, support for the \texttt{/} (\texttt{⟪}) and \texttt{\textbackslash{}} (\texttt{⟫}) operation needed to be added.

\begin{verbatim}
data Fin : Nat → Set where
  f0 : {n : Nat} → Fin (suc n)
  fs : {n : Nat} → Fin n → Fin (suc n)
  
data Type (n : Nat) : Set where
  con : Name → Type n
  var : Fin n → Type n
  _⟫_ : Type n → Type n → Type n
  _⟪_ : Type n → Type n → Type n
\end{verbatim}

The core idea of the McBride algorithm is to use types indexed by the \texttt{Fin} type to signify the amount of variables that the type contains. The main confusion that could occur is the thought that when we want to unify two types that these types need to have the same amount of variables present. The number of variables the \texttt{Fin} signifies is actually the amount of variables in the domain of the type, which do not need to be actually present. To give an extremely simple running example:

\begin{verbatim}
x y : Type 2
x = var (fs f0)
y = var (fs (fs f0))
\end{verbatim}

Both the types \texttt{x} and \texttt{y} have 2 variables in their domain, namely \texttt{var (fs f0)} and \texttt{var (fs (fs f0))}, \texttt{y} does not mention the first however, and \texttt{x} does not mention the second.

When unifying these two types successfully, at least one variable will get eliminated, this means that the number of variables in the domain will get lowered. In our example, the resulting type after unification will be \texttt{Type 1}. When eliminating a variable from these types, all the \texttt{Fin} expressions of all variables `larger' than the eliminated variable need to be lowered as well. This means that when we unify \texttt{x} and \texttt{y} so that \texttt{x} takes the value of \texttt{y}, the resulting variable cannot be \texttt{var (fs (fs f0))} because this \texttt{Fin} would be outside of the scope of \texttt{Type 1}. Therefore, \texttt{(fs (fs f0))} gets lowered to \texttt{(fs f0)}.

To apply the substitutions that the unification algorithm generates, we have constructed two functions. The first \texttt{apply} calls the unification procedure recursively with the current substitution as an argument to check if further unification is possible. This recursion is fairly costly however.

\begin{verbatim}
apply¹ : {n : Nat} → List (Typed n) → ∃ AList n → List (∃ Typed)
apply¹ [] subs = []
apply¹ ((w := term) ∷ l) ⟨ s , t ⟩ = ⟨ s , w := ((sub t) ◃) term ⟩ ∷ apply¹ l ⟨ s , t ⟩

apply : {n : Nat} → List (Typed n) → List (∃ Typed)
apply {n} list = apply' list [] ⟨ n , [] {n} ⟩
  where
  apply' : {n : Nat} → List (Typed n) → List (Typed n) → ∃ AList n → List (∃ Typed)
  apply' [] acc subs = apply¹ acc subs
  apply' (x ∷ list) acc subs with apply'' x list subs
    where
    apply'' : {n : Nat} → Typed n → List (Typed n) → ∃ AList n → Maybe (∃ AList n)
    apply'' t [] subs = no
    apply'' (w₁ := t₁) ((w₂ := t₂) ∷ l) subs with w₁ =W? w₂
    apply'' (w₁ := t₁) ((w₂ := t₂) ∷ l) subs | no = apply'' (w₁ := t₁) l subs
    apply'' (w₁ := t₁) ((w₂ := t₂) ∷ l) subs | yes with amgu t₁ t₂ subs
    apply'' (w₁ := t₁) ((w₂ := t₂) ∷ l) subs | yes | yes subs' = yes subs'
    apply'' (w₁ := t₁) ((w₂ := t₂) ∷ l) subs | yes | no = apply'' (w₁ := t₁) l subs
  apply' (x ∷ list) acc subs | no = apply' list (x ∷ acc) subs
  apply' (x ∷ list) acc subs | yes subs' = apply' list acc subs'
\end{verbatim}

The second implementation, \texttt{apply-alt}, applies any substitution globally before finding the next unification. This method reduces the recursive nature of the unification procedure, at the cost of a slower general procedure. Because application of substitutions is a much less computationally intensive procedure than unification however, the gains in efficiency are considerable. Another issue is that we have to convince Agda that our application function actually terminates, as it is not able to infer this by itself. This should not prove to be a problem in this case, as we can easily see that the procedure eliminates an element of the list at each iteration.

\begin{verbatim}
apply'¹ : {n : Nat} → List (Typed n) → (sub : ∃ AList n) → List (Typed (targ sub))
apply'¹ [] subs = []
apply'¹ ((w := term) ∷ l) ⟨ s , t ⟩ = w := ((sub t) ◃) term ∷ apply'¹ l ⟨ s , t ⟩

apply-alt' : {n : Nat} → (Typed n) → List (Typed n) → Maybe (∃ AList n)
apply-alt' x [] = no
apply-alt' (w₁ := t₁) ((w₂ := t₂) ∷ l) with w₁ =W? w₂
apply-alt' (w₁ := t₁) ((w₂ := t₂) ∷ l) | no = apply-alt' (w₁ := t₁) l
apply-alt' (w₁ := t₁) ((w₂ := t₂) ∷ l) | yes with mgu t₁ t₂ 
apply-alt' (w₁ := t₁) ((w₂ := t₂) ∷ l) | yes | yes subs' = yes subs'
apply-alt' (w₁ := t₁) ((w₂ := t₂) ∷ l) | yes | no = apply-alt' (w₁ := t₁) l

{-# TERMINATING #-}
apply-alt : {n : Nat} → List (Typed n) → List (∃ Typed)
apply-alt l = apply-alt'' l []
  where
  apply-alt'' : {n : Nat} → List (Typed n) → List (Typed n) → List (∃ Typed)
  apply-alt'' [] acc = map (λ ts → ⟨ n , ts ⟩) acc
  apply-alt'' (x ∷ list) acc with apply-alt' x list
  apply-alt'' (x ∷ list) acc | no = apply-alt'' list (x ∷ acc)
  apply-alt'' (x ∷ list) acc | yes subs = apply-alt'' (apply'¹ list subs) (apply'¹ acc subs)
\end{verbatim}

Both versions of the algorithm are `naive' in that they will always return a unifier. When two types cannot be unified, the function will simply leave both types as they are. This choice has the rather unattractive property that we cannot know the number of variables in our domain after unification beforehand. To get around this, we need the \texttt{∃} function, which abstracts away the index of the \texttt{Typed} type, which can be recovered in most cases. The advantage of this choice is that the algorithm deals with multiple type-assignments quite well and in an efficient manner. It should be investigated further if the current approach is indeed correct or if it needs further refinement.

\subsection{Buszkowski \& Penn \label{Decorate}}
\label{sec:orgade4bc4}

The decoration function that Buszkowski and Penn, which is quite simple to consider, seems like a complex beast in Agda. This is mostly due to the nature of our unification algorithm and its requirement that we keep track of the number of free variables in our domain.

\begin{verbatim}
decorate : {m : Nat} → Struct → Fin m → Term m → List (Typed m) → List (Typed m)
decorate [ x ] fin t acc = insert (x := t) acc _<t?_ -- (1)

decorate {m} (a ▹ f) (fs (fs fin)) (var v) acc
  = let fin'  = fs fin ♯                       -- (3)
        fin'' = fin ♯ ♯
  in decorate {m} f fin'' (var fin' ⟫ var v)   -- (4)
    (decorate {m} a fin'  (var fin') acc)      -- (2)
    
decorate {m} (f ◃ a) (fs (fs fin)) (var v) acc
  = let fin'  = fs fin ♯                       -- (3)
        fin'' = fin ♯ ♯
    in decorate {m} f fin'' (var v ⟪ var fin') -- (4)
      (decorate {m} a fin' (var fin') acc)     -- (2)
      
decorate {m} (a ▹ f) (fs fin) t acc
  = let fin'  = fs fin
        fin'' = ((fin ♯) ♭ (no-args a))        -- (5)
    in decorate {m} f fin'' (var (fs fin) ⟫ t) -- (4)
      (decorate {m} a fin' (var (fs fin)) acc) -- (2)
      
decorate {m} (f ◃ a) (fs fin) t acc
  = let fin'  = fs fin
        fin'' = ((fin ♯) ♭ (no-args a))        -- (5)
    in decorate {m} f fin'' (t ⟪ var (fs fin)) -- (4)
      (decorate {m} a fin' (var (fs fin)) acc) -- (2)
      
decorate s f0 t acc = acc 
\end{verbatim}

Each iteration through the tree carries with it the amount of variables left and the type with which to decorate the current node or leaf. When encountering a leaf, the function simply assigns the type to that leaf (1). When encountering a node, the function recursively calls itself to the argument branch (2) while lowering the number of variables by one if the current type is a variable (3). For the functor branch, the type needs to be a composition of the argument branch type and the type of the current node (4). Moreover, the number of variables for that branch needs to be lowered by the number of arguments that are present in the argument branch (5).

When testing the Buszkowski \& Penn algorithm using the \texttt{aⁿbⁿ} grammar described in figure \ref{anbn}, it became apparent that when applying this algorithm to sets of typed structures, the order of the types before unification is important. If we order the types in ascending order based on the number of connectives, the resulting set of types after unification has a maximum number of connectives per type that is equal to the maximum number of connectives in the original set. Unordered, however, this number can and does grow at an explosive pace. There is no mention of this phenomenon in the papers by Buszkowski or Kanazawa. For now it is sufficient to sort the terms on number of connectives after or during decoration (1), but a formal ordering of terms might be in order for the final version of our algorithm.

\subsection{Morris \label{Morris}}
\label{sec:org3d9544e}

For the Morris-algorithm as described in \cite{vanemden1988}, we need the following definition of a (typed) lambda term and a function to extract the type from the typed term.

\begin{verbatim}
data Term : Set where
  con  : Word → Term
  _∘_  : Term → Term → Term
  ƛ_⇒_ : Word → Term → Term
  
data TTerm (n : Nat) : Set where
  con_∶_ : Word → Type n → TTerm n
  _∘_∶_  : TTerm n → TTerm n → Type n → TTerm n
  ƛ_⇒_∶_ : TTerm n → TTerm n → Type n → TTerm n

_* : {n : Nat} → TTerm n → Type n
(con x ∶ type) *   = type
(M ∘ N ∶ type) *   = type
(ƛ x ⇒ M ∶ type) * = type
\end{verbatim}

The decorate function that we use to obtain the meta-variables is very much like the decorate function that we defined for the Buszkowski \& Penn algorithm, but we store the meta-types in the lambda-term structure by converting the term to a typed term (\texttt{TTerm}).

\begin{verbatim}
decorate : {m : Nat} → (t : Term) → Fin m → List (Typed m) → TTerm m

decorate (con x) fin acc with type? (con x) acc
decorate (con x) fin acc | no = con x ∶ var fin
decorate (con x) fin acc | yes t = con x ∶ t

decorate (f ∘ g) fin acc = let fin-f = (fin ♭ 1)
                               fin-g = (fin ♭ suc (no-vars f))
                               f' = (decorate f fin-f acc)
                               g' = (decorate g fin-g acc) 
                           in f ∘ g ∶ (var fin)
                           
decorate (ƛ x ⇒ M) fin acc = let acc' = ((con x := var (fin ♭ 1)) :> acc)
                                 x' = (decorate (con x) (fin ♭ 1) acc')
                                 M' = (decorate M (fin ♭ 2) acc')
                             in ƛ x' ⇒ M' ∶ (var fin)
\end{verbatim}

The morris-mgu function is merely a wrapper around this function to allow us to insert other logic rules instead of \texttt{il-amgu}.
The \texttt{il-amgu} function essentially encodes step 2 and 3 from chapter \ref{morris} where \texttt{amgu} is the unification function from the McBride module. \texttt{amgu (M *) ((N *) ⟫ type) subs} should be read as, try to unify the meta-type of \texttt{M} with the target type \texttt{(N' ⟫ (M∘N)')}, where N' is the meta-type of \texttt{N} and \texttt{(M∘N)'} is the type of the function application of \texttt{M} and \texttt{N}.

\begin{verbatim}
il-amgu : {m : Nat}(t : TTerm m) → ∃ (AList m) → Maybe (∃ (AList m))
il-amgu (con x   ∶ type) subs = yes subs
il-amgu (M ∘ N   ∶ type) subs = amgu (M *) ((N *) ⟫ type) subs
il-amgu (ƛ x ⇒ M ∶ type) subs = amgu type ((x *) ⟫ (M *)) subs

morris-mgu : {m : Nat} → (t : TTerm m) → Maybe (∃ (AList m)) → Maybe (∃ (AList m))
morris-mgu _ no = no
morris-mgu (con x ∶ type) (yes subs) = yes subs
morris-mgu (M ∘ N ∶ type) (yes subs) with il-amgu (N ∘ M ∶ type) subs
... | yes subs' = morris-mgu N (morris-mgu M (yes subs') unif) unif
... | no = no

morris-mgu (ƛ x ⇒ M ∶ type) (yes subs) with il-amgu (ƛ x ⇒ M ∶ type) subs
... | yes subs' = morris-mgu M (morris-mgu x (yes subs') unif) unif
... | no = no
\end{verbatim}


\section{Conclusion}
\label{sec:orgf9f1aa4}

The aim of this research is to develop a method of proof search for Lambek style calculi in Agda, in particular for the version which includes modalities for licensed structural control. Our main approach will be to extend the `Morris algorithm' as presented by van Emden to include directionality and resource-sensitivity. This extension will be mainly driven by the techniques proposed by Buszkowski, Penn and Kanazawa to learn grammars from data, and by Kokke and Swierstra for its implementation in Agda. The resulting implementation should be transparent, readable and easily extensible to include other logics.


\section{Bibliography}
\label{sec:orge933629}
\renewcommand{\section}[2]{}
\bibliography{../Literatuur/sources}
\end{document}